McElieceCCA2PrivateKeyParameters (Bouncy Castle Library 1.52 API Specification)

org.bouncycastle.pqc.crypto.mceliece

## Class McElieceCCA2PrivateKeyParameters

- java.lang.Object
- - org.bouncycastle.crypto.params.AsymmetricKeyParameter
  - - org.bouncycastle.pqc.crypto.mceliece.McElieceCCA2KeyParameters
    - - org.bouncycastle.pqc.crypto.mceliece.McElieceCCA2PrivateKeyParameters

- All Implemented Interfaces:
    CipherParameters

      public class McElieceCCA2PrivateKeyParameters
      extends McElieceCCA2KeyParameters

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `McElieceCCA2PrivateKeyParameters(java.lang.String oid, int n, int k, byte[] encFieldPoly, byte[] encGoppaPoly, byte[] encP, byte[] encH, byte[][] encQInv, McElieceCCA2Parameters params)` Constructor used by the `McElieceKeyFactory`.
    `McElieceCCA2PrivateKeyParameters(java.lang.String oid, int n, int k, GF2mField field, PolynomialGF2mSmallM gp, Permutation p, GF2Matrix h, PolynomialGF2mSmallM[] qInv, McElieceCCA2Parameters params)` Constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `GF2mField` | `getField()`
    `PolynomialGF2mSmallM` | `getGoppaPoly()`
    `GF2Matrix` | `getH()`
    `int` | `getK()`
    `int` | `getN()`
    `java.lang.String` | `getOIDString()`
    `Permutation` | `getP()`
    `PolynomialGF2mSmallM[]` | `getQInv()`
    `int` | `getT()`

    - ### Methods inherited from class org.bouncycastle.pqc.crypto.mceliece.McElieceCCA2KeyParameters

      `getParameters`

    - ### Methods inherited from class org.bouncycastle.crypto.params.AsymmetricKeyParameter

      `isPrivate`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### McElieceCCA2PrivateKeyParameters

          public McElieceCCA2PrivateKeyParameters(java.lang.String oid,
                                          int n,
                                          int k,
                                          GF2mField field,
                                          PolynomialGF2mSmallM gp,
                                          Permutation p,
                                          GF2Matrix h,
                                          PolynomialGF2mSmallM[] qInv,
                                          McElieceCCA2Parameters params)

      Constructor.
      Parameters:
        `n` - the length of the code
        `k` - the dimension of the code
        `field` - the finite field `GF(2m)`
        `gp` - the irreducible Goppa polynomial
        `p` - the permutation
        `h` - the canonical check matrix
        `qInv` - the matrix used to compute square roots in `(GF(2^m))^t`
        `params` - McElieceCCA2Parameters

    - #### McElieceCCA2PrivateKeyParameters

          public McElieceCCA2PrivateKeyParameters(java.lang.String oid,
                                          int n,
                                          int k,
                                          byte[] encFieldPoly,
                                          byte[] encGoppaPoly,
                                          byte[] encP,
                                          byte[] encH,
                                          byte[][] encQInv,
                                          McElieceCCA2Parameters params)

      Constructor used by the `McElieceKeyFactory`.
      Parameters:
        `n` - the length of the code
        `k` - the dimension of the code
        `encFieldPoly` - the encoded field polynomial defining the finite field `GF(2m)`
        `encGoppaPoly` - the encoded irreducible Goppa polynomial
        `encP` - the encoded permutation
        `encH` - the encoded canonical check matrix
        `encQInv` - the encoded matrix used to compute square roots in `(GF(2^m))^t`
        `params` - McElieceCCA2Parameters

  - ### Method Detail

    - #### getN

          public int getN()

      Returns:
        the length of the code

    - #### getK

          public int getK()

      Returns:
        the dimension of the code

    - #### getT

          public int getT()

      Returns:
        the degree of the Goppa polynomial (error correcting capability)

    - #### getField

          public GF2mField getField()

      Returns:
        the finite field

    - #### getGoppaPoly

          public PolynomialGF2mSmallM getGoppaPoly()

      Returns:
        the irreducible Goppa polynomial

    - #### getP

          public Permutation getP()

      Returns:
        the permutation P

    - #### getH

          public GF2Matrix getH()

      Returns:
        the canonical check matrix H

    - #### getQInv

          public PolynomialGF2mSmallM[] getQInv()

      Returns:
        the matrix used to compute square roots in `(GF(2^m))^t`

    - #### getOIDString

          public java.lang.String getOIDString()